#ifndef __CHB_COLOR_COMPARE
#define __CHB_COLOR_COMPARE

#include <math.h>

static float chb_compare_lab_e(float const * lab0, float const * lab1)
{
	//from https://en.wikipedia.org/wiki/Color_difference
	//supposedly CIE76 delta E
	float LL = (lab1[0]-lab0[0]);
	float aa = (lab1[1]-lab0[1]);
	float bb = (lab1[2]-lab0[2]);

	LL = LL * LL;
	aa = aa * aa;
	bb = bb * bb;

	float dE = sqrtf(LL + aa + bb);

	return dE;
}

static float chb_compare_rgb_e(float const * rgb0, float const * rgb1)
{
	float lab0[3];
	float lab1[3];

	chb_rgb_to_lab(rgb0, lab0);
	chb_rgb_to_lab(rgb1, lab1);
	float dE = chb_compare_lab_e(lab0, lab1);
	return dE;
}

#endif
