#ifndef __CHB_CONVERT_PALETTE
#define __CHB_CONVERT_PALETTE

#ifdef WIN32
#include <windows.h>
#endif

unsigned char chb_convert_palette_to_ansi3fg(const chb_palette_code palette_code)
{
	unsigned char ansi;
	ansi = palette_code & 0x07;
	ansi = ansi + 30;
	return ansi;
}

unsigned char chb_convert_palette_to_ansi3bg(const chb_palette_code palette_code)
{
	unsigned char ansi;
	ansi = palette_code & 0x07;
	ansi = ansi + 40;
	return ansi;
}

unsigned char chb_convert_palette_to_ansi4fg(const chb_palette_code palette_code)
{
	unsigned char ansi;
	unsigned char dark_mode;
	dark_mode = (palette_code & 0x08) >> 3;
	ansi = palette_code & 0x07;

	if(dark_mode)
		ansi = ansi + 90;
	else
		ansi = ansi + 30;

	return ansi;
}

unsigned char chb_convert_palette_to_ansi4bg(const chb_palette_code palette_code)
{
	unsigned char ansi;
	unsigned char dark_mode;
	dark_mode = (palette_code & 0x08) >> 3;
	ansi = palette_code & 0x07;

	if(dark_mode)
		ansi = ansi + 100;
	else
		ansi = ansi + 40;

	return ansi;
}

#ifdef WIN32
WORD chb_convert_palette_to_ms4fg(chb_palette_code const color)
{
	WORD code = 0;
	unsigned char mode = (color & 0x08) >> 3;
	unsigned char ansi_code = color & 0x07;

	switch (ansi_code)
	{
	case 0:
		code = 0;
		break;
	case 1:
		code = FOREGROUND_RED;
		break;
	case 2:
		code = FOREGROUND_GREEN;
		break;
	case 3:
		code = FOREGROUND_RED | FOREGROUND_GREEN;
		break;
	case 4:
		code = FOREGROUND_BLUE;
		break;
	case 5:
		code = FOREGROUND_BLUE | FOREGROUND_RED;
		break;
	case 6:
		code = FOREGROUND_BLUE | FOREGROUND_GREEN;
		break;
	case 7:
		code = FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE;
		break;
	}

	if (mode)
		code |= FOREGROUND_INTENSITY;

	return code;
}

WORD chb_convert_palette_to_ms4bg(chb_palette_code const color)
{
	WORD code = 0;
	unsigned char mode = (color & 0x08) >> 3;
	unsigned char ansi_code = color & 0x07;

	switch (ansi_code)
	{
	case 0:
		code = 0;
		break;
	case 1:
		code = BACKGROUND_RED;
		break;
	case 2:
		code = BACKGROUND_GREEN;
		break;
	case 3:
		code = BACKGROUND_RED | BACKGROUND_GREEN;
		break;
	case 4:
		code = BACKGROUND_BLUE;
		break;
	case 5:
		code = BACKGROUND_BLUE | BACKGROUND_RED;
		break;
	case 6:
		code = BACKGROUND_BLUE | BACKGROUND_GREEN;
		break;
	case 7:
		code = BACKGROUND_RED | BACKGROUND_GREEN | BACKGROUND_BLUE;
		break;
	}

	if (mode)
		code |= BACKGROUND_INTENSITY;

	return code;
}
#endif

#endif
