
#ifndef __OUTPUT_PIXEL
#define __OUTPUT_PIXEL

#ifdef WIN32
#include <windows.h>
#endif

void chb_output_ansi8bit_pixels(chb_rgb const * top_color, chb_rgb const * bot_color)
{
	char hasBotColor = bot_color != NULL;

	unsigned char top_code;
	chb_closest_color_8(top_color, &top_code);

	if(hasBotColor) {
		unsigned char bot_code;
		chb_closest_color_8(bot_color, &bot_code);
		chb_print_ansi8bit_code(top_code, bot_code);
	}
	else
		chb_print_ansi8bit_nobg_code(top_code);

}

#ifdef WIN32
void chb_output_ms_console_pixels(chb_rgb const * top_color, chb_rgb const * bot_color)
{
	chb_palette_code top_palette, bot_palette;
	char hasBotColor = bot_color != NULL;
	WORD fg = 0;
	WORD bg = 0;

	chb_closest_color_4(top_color, &top_palette);
	fg = chb_convert_palette_to_ms4fg(top_palette);
	if(hasBotColor) {
		chb_closest_color_4(bot_color, &bot_palette);
		bg = chb_convert_palette_to_ms4bg(bot_palette);
		chb_set_ms4_code(fg, bg);
	}
	else
		chb_set_ms4_code(fg, 0);
}
#endif

void chb_output_ansi3bit_pixels(chb_rgb const * top_color, chb_rgb const * bot_color)
{
	unsigned char fg_ansi, bg_ansi;
	chb_palette_code top_palette, bot_palette;
	char hasBotColor = bot_color != NULL;

	chb_closest_color_3(top_color, &top_palette);
	fg_ansi = chb_convert_palette_to_ansi3fg(top_palette);

	if(hasBotColor) {
		chb_closest_color_3(bot_color, &bot_palette);
		bg_ansi = chb_convert_palette_to_ansi3bg(bot_palette);
		chb_print_ansi4bit_code(fg_ansi, bg_ansi);
	}
	else
		chb_print_ansi4bit_nobg_code(fg_ansi);
}


void chb_output_ansi4bit_pixels(chb_rgb const * top_color, chb_rgb const * bot_color)
{
	unsigned char fg_ansi, bg_ansi;
	chb_palette_code top_palette, bot_palette;
	char hasBotColor = bot_color != NULL;

	chb_closest_color_4(top_color, &top_palette);
	fg_ansi = chb_convert_palette_to_ansi4fg(top_palette);

	if(hasBotColor) {
		chb_closest_color_4(bot_color, &bot_palette);
		bg_ansi = chb_convert_palette_to_ansi4bg(bot_palette);
		chb_print_ansi4bit_code(fg_ansi, bg_ansi);
	}
	else
		chb_print_ansi4bit_nobg_code(fg_ansi);
}

void chb_output_ansi24bit_pixels(chb_rgb const * top_color, chb_rgb const * bot_color)
{
	chb_print_ansi24bit_code(top_color, bot_color);
}

#endif
