#ifndef __MINUNIT
#define __MINUNIT

#include <stdio.h>
#include <string.h>

/* minunit.h
 from http://www.jera.com/techinfo/jtns/jtn002.html
 */

#ifndef MU_RES_COL
#define MU_RES_COL 50
#endif

#ifndef MU_USE_COL
#define MU_USE_COL 1
#endif

typedef struct min_unit_result {
	int pass;
	char const * msg;
} min_result;

//typedef struct min_unit_result min_result;

#define mu_assert(_msg, test) do { \
	struct min_unit_result r; \
	r.msg=_msg; \
	r.pass=0; \
	if (!(test)) return r;\
} while (0)

#define mu_pass(_msg) do { \
	struct min_unit_result r; \
	r.msg=_msg; r.pass=1; \
	return r;\
} while (0)

#define mu_run_test(test) do { \
	struct min_unit_result r = test(); \
	tests_run++; \
	printf("%s", r.msg); int mu_i=0; \
	while(strlen(r.msg)+mu_i < MU_RES_COL) {printf(" "); mu_i++;} \
	printf("["); \
	if (r.pass) { if(MU_USE_COL) printf("\033[1;32m"); printf("pass"); } \
	else { if(MU_USE_COL) printf("\033[1;31m"); printf("fail"); } \
	if(MU_USE_COL) printf("\033[0m"); printf("]\n"); \
} while (0)
extern int tests_run;

#define TEST_EPSILON 0.001f

#endif
