#include <wchar.h>
#include <locale.h>
#include <stdlib.h>
#include <stdio.h>

#ifdef WIN32
#include <windows.h>

void chb_print_test_color_hardcoded_win32()
{
	HANDLE console = GetStdHandle(STD_OUTPUT_HANDLE);
	printf("Win32 foreground console colors\n");

	SetConsoleTextAttribute(console, FOREGROUND_RED );
	printf("%c", '0');
	SetConsoleTextAttribute(console, FOREGROUND_GREEN);
	printf("%c", '1');
	SetConsoleTextAttribute(console, FOREGROUND_BLUE);
	printf("%c", '2');
	SetConsoleTextAttribute(console, FOREGROUND_RED | FOREGROUND_BLUE);
	printf("%c", '3');
	SetConsoleTextAttribute(console, FOREGROUND_RED | FOREGROUND_GREEN);
	printf("%c", '4');
	SetConsoleTextAttribute(console, FOREGROUND_BLUE | FOREGROUND_GREEN);
	printf("%c", '5');
	SetConsoleTextAttribute(console, FOREGROUND_RED | FOREGROUND_BLUE | FOREGROUND_GREEN);
	printf("%c", '6');
	SetConsoleTextAttribute(console, 0);
	printf("%c", '7');
	printf("\n");

	SetConsoleTextAttribute(console, FOREGROUND_INTENSITY | FOREGROUND_RED);
	printf("%c", '0');
	SetConsoleTextAttribute(console, FOREGROUND_INTENSITY | FOREGROUND_GREEN);
	printf("%c", '1');
	SetConsoleTextAttribute(console, FOREGROUND_INTENSITY | FOREGROUND_BLUE);
	printf("%c", '2');
	SetConsoleTextAttribute(console, FOREGROUND_INTENSITY | FOREGROUND_RED | FOREGROUND_BLUE);
	printf("%c", '3');
	SetConsoleTextAttribute(console, FOREGROUND_INTENSITY | FOREGROUND_RED | FOREGROUND_GREEN);
	printf("%c", '4');
	SetConsoleTextAttribute(console, FOREGROUND_INTENSITY | FOREGROUND_BLUE | FOREGROUND_GREEN);
	printf("%c", '5');
	SetConsoleTextAttribute(console, FOREGROUND_INTENSITY | FOREGROUND_RED | FOREGROUND_BLUE | FOREGROUND_GREEN);
	printf("%c", '6');
	SetConsoleTextAttribute(console, FOREGROUND_INTENSITY );
	printf("%c", '7');
	printf("\n");

	SetConsoleTextAttribute(console, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);
	printf("Win32 background console colors\n");

	SetConsoleTextAttribute(console, BACKGROUND_RED);
	printf("%c", '0');
	SetConsoleTextAttribute(console, BACKGROUND_GREEN);
	printf("%c", '1');
	SetConsoleTextAttribute(console, BACKGROUND_BLUE);
	printf("%c", '2');
	SetConsoleTextAttribute(console, BACKGROUND_RED | BACKGROUND_BLUE);
	printf("%c", '3');
	SetConsoleTextAttribute(console, BACKGROUND_RED | BACKGROUND_GREEN);
	printf("%c", '4');
	SetConsoleTextAttribute(console, BACKGROUND_BLUE | BACKGROUND_GREEN);
	printf("%c", '5');
	SetConsoleTextAttribute(console, BACKGROUND_RED | BACKGROUND_BLUE | BACKGROUND_GREEN);
	printf("%c", '6');
	SetConsoleTextAttribute(console, 0);
	printf("%c", '7');
	printf("\n");

	SetConsoleTextAttribute(console, BACKGROUND_INTENSITY | BACKGROUND_RED);
	printf("%c", '0');
	SetConsoleTextAttribute(console, BACKGROUND_INTENSITY | BACKGROUND_GREEN);
	printf("%c", '1');
	SetConsoleTextAttribute(console, BACKGROUND_INTENSITY | BACKGROUND_BLUE);
	printf("%c", '2');
	SetConsoleTextAttribute(console, BACKGROUND_INTENSITY | BACKGROUND_RED | BACKGROUND_BLUE);
	printf("%c", '3');
	SetConsoleTextAttribute(console, BACKGROUND_INTENSITY | BACKGROUND_RED | BACKGROUND_GREEN);
	printf("%c", '4');
	SetConsoleTextAttribute(console, BACKGROUND_INTENSITY | BACKGROUND_BLUE | BACKGROUND_GREEN);
	printf("%c", '5');
	SetConsoleTextAttribute(console, BACKGROUND_INTENSITY | BACKGROUND_RED | BACKGROUND_BLUE | BACKGROUND_GREEN);
	printf("%c", '6');
	SetConsoleTextAttribute(console, BACKGROUND_INTENSITY);
	printf("%c", '7');
	printf("\n");

	SetConsoleTextAttribute(console, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);
	printf("\n");
}

void chb_print_test_color_loop_win32()
{
	//this methods assumes values of the constants, but works for now
	HANDLE console = GetStdHandle(STD_OUTPUT_HANDLE);
	printf("Win32 foreground console colors\n");

	for (int i = 0; i < 8; i++) {
		SetConsoleTextAttribute(console, i);
		printf("%c", '0' + i);
	}
	printf("\n");
	for (int i = 0; i < 8; i++) {
		SetConsoleTextAttribute(console, i | FOREGROUND_INTENSITY);
		printf("%c", '0' + i);
	}
	printf("\n");

	SetConsoleTextAttribute(console, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);
	printf("Win32 background console colors\n");
	for (int i = 0; i < 8; i++) {
		SetConsoleTextAttribute(console, i << 4);
		printf("%c", '0' + i);
	}
	printf("\n");
	for (int i = 0; i < 8; i++) {
		SetConsoleTextAttribute(console, (i << 4) | BACKGROUND_INTENSITY);
		printf("%c", '0' + i);
	}
	printf("\n");

	SetConsoleTextAttribute(console, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);
	printf("\n");
}

#endif

void chb_print_test_color_24bit()
{
	printf("24bit bg color mode (48;2)\n");

	int r=0;
	int g=0;
	int b=0;

	printf("r ");
	for(int i=0; i<25; i++)
		printf("\033[48;2;%d;%d;%dm ", r+i*10, g, b);
	printf("\033[0m");
	printf("\n");

	printf("g ");
	for(int i=0; i<25; i++)
		printf("\033[48;2;%d;%d;%dm ", r, g+10*i, b);
	printf("\033[0m");
	printf("\n");

	printf("b ");
	for(int i=0; i<25; i++)
		printf("\033[48;2;%d;%d;%dm ", r, g, b+10*i);
	printf("\033[0m");
	printf("\n");
}

void chb_print_test_color_256()
{
	printf("256bg color mode (bg, 48;5)\n");

	printf("0-f\n");
	for(int i=0; i<16; i++) {
		printf("\033[48;5;%dm", i);
		printf(" ");
		//printf("\033[38;5;%dm", i);
		//wprintf(L"\u2588");
	}
	printf("\033[0m"); printf("\n");

	for(int i=0; i<6; i++)
	{
		printf("%02x", (i*36+15));
		printf("     ");
	}
	printf("\n");

	for(int g=0; g<6; g++)
	{
		for(int r=0; r<6; r++)
		{
			for(int b=0; b<6; b++)
			{
				printf("\033[48;5;%dm", 16 + (r*36 + g*6 + b) ); //color cube
				printf(" ");
				//printf("\033[38;5;%dm", 16 + (r*36 + g*6 + b) ); //color cube
				//wprintf(L"\u2588");
			}
			printf("\033[0m");
			printf(" ");
		}
		printf("\033[0m");
		printf("\n");
	}

	printf("%02x\n", 232);
	for(int i=232; i<256; i++) {
		printf("\033[48;5;%dm", i);
		printf(" ");
		//printf("\033[38;5;%dm", i);
		//wprintf(L"\u2588");
	}
	printf("\033[0m");
	printf("\n");
}

void chb_print_test_color_8fg()
{
	printf("8fg color mode (30-37)\n");
	for(int i=0; i<8; i++)
	{
		printf("\033[%dm", 30+i);
		printf("%c", 48+i);
		//wprintf(L"\u2588");
	}
	printf("\033[0m"); printf("\n");

	printf("8fg color mode bold (1;30-1;37)\n");
	for(int i=0; i<8; i++)
	{
		printf("\033[1;%dm", 30+i);
		printf("%c", 65+i);
		//wprintf(L"\u2588");
	}
	printf("\033[0m"); printf("\n");
}

void chb_print_test_color_8bg()
{
	printf("8bg color mode (40-47)\n");
	for(int i=0; i<8; i++)
	{
		printf("\033[%dm", 40+i);
		printf("%c", 48+i);
		//wprintf(L"\u2588");
	}
	printf("\033[0m"); printf("\n");

	printf("8bg color mode bold (1;40-1;47)\n");
	for(int i=0; i<8; i++)
	{
		printf("\033[1;%dm", 40+i);
		printf("%c", 65+i);
		//wprintf(L"\u2588");
	}
	printf("\033[0m"); printf("\n");
}

void chb_print_test_color_16fg()
{
	printf("16fg color mode (30-37, 90-97)\n");
	for(int i=0; i<8; i++)
	{
		printf("\033[%dm", 30+i);
		printf("%c", 48+i);
		//wprintf(L"\u2588");
	}
	printf("\033[0m"); printf("\n");

	for(int i=0; i<8; i++)
	{
		printf("\033[%dm", 90+i);
		printf("%c", 48+i);
		//wprintf(L"\u2588");
	}
	printf("\033[0m"); printf("\n");
}

void chb_print_test_color_16bg()
{
	printf("16bg color mode (40-47, 100-107)\n");
	for(int i=0; i<8; i++)
	{
		printf("\033[%dm", 40+i);
		printf("%c", 48+i);
		//wprintf(L"\u2588");
	}
	printf("\033[0m"); printf("\n");

	for(int i=0; i<8; i++)
	{
		printf("\033[%dm", 100+i);
		printf("%c", 48+i);
		//wprintf(L"\u2588");
	}
	printf("\033[0m"); printf("\n");
}


void chb_print_test_color_cases()
{
#ifdef WIN32
	chb_print_test_color_loop_win32();

	chb_print_test_color_8fg();
	printf("\033[0m"); printf("\n");
	chb_print_test_color_8bg();
	printf("\033[0m"); printf("\n");
	printf("\n");
#else
	chb_print_test_color_8fg();
	printf("\033[0m"); printf("\n");
	chb_print_test_color_8bg();
	printf("\033[0m"); printf("\n");

	chb_print_test_color_16fg();
	printf("\033[0m"); printf("\n");
	chb_print_test_color_16bg();
	printf("\033[0m"); printf("\n");

	chb_print_test_color_256();
	printf("\033[0m"); printf("\n");

	chb_print_test_color_24bit();
	printf("\033[0m"); printf("\n");
#endif
}

void chb_print_test_encoding_ascii()
{
	printf("ASCII\n");
	for(int i=65; i<91; i++)
		printf("%c", i);
	printf("\n");
}

void chb_print_test_encoding_high_ascii()
{
	printf("High ASCII 176-178\n");
	for(int i=176; i<179; i++)
		printf("%c", i);
	printf("\n");
	printf("High ASCII 219-223\n");
	for(int i=219; i<224; i++)
		printf("%c", i);
	printf("\n");
	printf("High ASCII 254\n");
	printf("%c\n", 254);
}

#ifdef WIN32
chb_print_test_encoding_win32_page1252()
{
	HANDLE console = GetStdHandle(STD_OUTPUT_HANDLE);
	unsigned int cp = GetConsoleCP();
	SetConsoleCP(1252);

	printf("Win32: Codepage 1252 (IBM 437) 219-223\n");
	for(int i=219; i<224; i++)
		printf("%c", i);
	printf("\n");

	SetConsoleCP(cp);
}
#endif

void chb_print_test_encoding_unicode_w()
{
	printf("Unicode wprintf 0x2580-0x259f\n");
	for(wchar_t i=0x2580; i<0x259f; i++)
		wprintf(L"%lc", i);
	printf("\n");
}

void chb_print_test_encoding_utf8()
{
	printf("Unicode manual UTF-8 0x2580-0x259f\n");
	for(int i=0; i<0x259f - 0x2580; i++)
	{
		printf("%c%c%c", 0xe2, 0x96, i + 128);
	}
	printf("\n");
}

void chb_print_test_encoding_utf16()
{
	printf("Unicode manual UTF-16 0x2580-0x259f\n");
	for(int i=0x2580; i<0x259f; i++)
	{
		printf("%lc", i);
	}
	printf("\n");
}

#ifdef WIN32
chb_print_test_encoding_win32_unicode()
{
	HANDLE console = GetStdHandle(STD_OUTPUT_HANDLE);
	unsigned int cp = GetConsoleCP();
	SetConsoleCP(CP_UTF8);

	printf("Win32: Codepage UTF8\n");
	chb_print_test_encoding_unicode_w();
	chb_print_test_encoding_utf8();
	chb_print_test_encoding_utf16();
	printf("\n");

	SetConsoleCP(cp);
}
#endif

void chb_print_test_encoding()
{
	chb_print_test_encoding_ascii();
	printf("\n");

	chb_print_test_encoding_high_ascii();
	printf("\n");

#ifdef WIN32
	chb_print_test_encoding_win32_page1252();
	printf("\n");
	chb_print_test_encoding_win32_unicode();
	printf("\n");
#endif

	chb_print_test_encoding_unicode_w();
	chb_print_test_encoding_utf8();
	chb_print_test_encoding_utf16();

	printf("\n");
}

int main(int i, char** c)
{
	setlocale(LC_ALL, "");

	chb_print_test_color_cases();

	chb_print_test_encoding();

	return 0;
}


