#ifndef _UNITRGB
#define _UNITRGB

#include "minunit.h"
#include "rgb.h"


static min_result test_rgb_set() {
	chb_rgb rgb;
	unsigned char v[3] = {40, 41, 42};
	chb_rgb_set_r(&rgb, v[0]);
	chb_rgb_set_g(&rgb, v[1]);
	chb_rgb_set_b(&rgb, v[2]);
	mu_assert("chb_rgb_set_r", rgb.c[0] == v[0]);
	mu_assert("chb_rgb_set_g", rgb.c[1] == v[1]);
	mu_assert("chb_rgb_set_b", rgb.c[2] == v[2]);
	mu_pass("rgb set");
}

static min_result test_set_rgb() {
	chb_rgb rgb;
	unsigned char v[3] = {2, 3, 4};
	chb_rgb_set_rgb(&rgb, v[0], v[1], v[2]);
	mu_assert("chb_rgb_set_rgb",
			rgb.c[0] == v[0] &&
			rgb.c[1] == v[1] &&
			rgb.c[2] == v[2]);
	mu_pass("rgb set all");
}

static min_result test_set_rgbv() {
	chb_rgb rgb;
	unsigned char v[3] = {5, 6, 7};
	chb_rgb_set_rgbv(&rgb, v);
	mu_assert("chb_rgb_set_rgbv",
			rgb.c[0] == v[0] &&
			rgb.c[1] == v[1] &&
			rgb.c[2] == v[2]);
	mu_pass("rgb setv");
}

static min_result test_rgb_get() {
	chb_rgb rgb;
	unsigned char v[3] = {5, 6, 7};
	chb_rgb_set_rgbv(&rgb, v);
	mu_assert("chb_get_r", chb_rgb_get_r(&rgb) == v[0]);
	mu_assert("chb_get_g", chb_rgb_get_g(&rgb) == v[1]);
	mu_assert("chb_get_b", chb_rgb_get_b(&rgb) == v[2]);
	mu_pass("rgb get");
}

#endif
