#ifndef __VIEW_TERM_H
#define __VIEW_TERM_H

#if (defined(unix) || defined(__unix__) || defined(__unix)) && !defined(__APPLE__) //breaks on apple for some reason
#include <unistd.h>
#endif

#include <stdlib.h>
#ifndef WIN32
#include <sys/ioctl.h>
#endif
static unsigned int get_term_width()
{
	//Getting lines/cols should work for single image
	//Otherwise, try more http://stackoverflow.com/questions/1022957/getting-terminal-width-in-c
	unsigned int v = 80;

	char * c = getenv("COLUMNS");
	if(c != NULL)
	{
		v = atoi(c);
	}
	else
	{
#ifdef WIN32
		//This leaves 1 column empty due to have Win32 handles newlines and line wrapping
		CONSOLE_SCREEN_BUFFER_INFO info;
		GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE), &info);
		v = info.srWindow.Right - info.srWindow.Left;
#else
		struct winsize w;
		ioctl(STDOUT_FILENO, TIOCGWINSZ, &w);
		v = w.ws_col;
#endif
	}

	return v;
}

static unsigned int get_term_height()
{
	unsigned int v = 24;

	char * c = getenv("LINES");
	if(c != NULL)
	{
		v = atoi(c);
	}
	else
	{
#ifdef WIN32
		CONSOLE_SCREEN_BUFFER_INFO info;
		GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE), &info);
		v = info.srWindow.Bottom - info.srWindow.Top + 1;
#else
		struct winsize w;
		ioctl(STDOUT_FILENO, TIOCGWINSZ, &w);
		v = w.ws_row;
#endif
	}

	return v;
}

static unsigned int get_canvas_width()
{
	unsigned int t = get_term_width();
	unsigned int c = t;
	return c;
}

static unsigned int get_canvas_height()
{
	unsigned int t = get_term_height();
	unsigned int c = (t-1) * 2;
	return c;
}

#endif

